--------------------------------------------------------------------------------
-- -- Copyright (c) 2009 Xilinx, Inc.
-- -- This design is confidential and proprietary of Xilinx, All Rights
-- Reserved.
--------------------------------------------------------------------------------
-- -   ____  ____
-- -  /   /\/   /
-- - /___/  \  /   Vendor: Xilinx
-- - \   \   \/    Version: 1.0
-- -  \   \        Filename: count_to_128.vhd
-- -  /   /        
-- - /___/   /\    Date Created: 07/14/2009 
-- - \   \  /  \   
-- -  \___\/\___\
-- - 
-- -Revision History:
--------------------------------------------------------------------------------

-- Library declarations
--
-- Standard IEEE libraries
--
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

ENTITY count_to_128 IS
   PORT (
      --This module counts up/down between 0 to 128

      clk                     : IN std_logic;   
      rst                     : IN std_logic;   
      count                   : IN std_logic;   
      ud                      : IN std_logic;   
      counter_value           : OUT std_logic_vector(6 DOWNTO 0));   
END count_to_128;

ARCHITECTURE translated OF count_to_128 IS


   SIGNAL counter_value_preserver  :  std_logic_vector(6 DOWNTO 0);   --synthesis syn_noprune = 1
   SIGNAL counter_value_int            :  std_logic_vector(6 DOWNTO 0);   

BEGIN


   PROCESS (clk, rst)
      VARIABLE temp   : std_logic_vector(1 DOWNTO 0);
   BEGIN
      IF (rst = '1') THEN
         counter_value_int  <= "0000000";    
      ELSIF (clk'EVENT AND clk = '1') THEN
         temp := count & ud;
         CASE temp IS
            WHEN "00" => counter_value_int  <= "0000000";    
            WHEN "01" => counter_value_int  <= counter_value_preserver;    
            WHEN "10" => counter_value_int  <= counter_value_preserver - "0000001";    
            WHEN "11" => counter_value_int  <= counter_value_preserver + "0000001";    
            WHEN OTHERS  => counter_value_int  <= "0000000";                
         END CASE;
      END IF;
   END PROCESS;
   counter_value_preserver <= counter_value_int ;

   counter_value <= counter_value_int ;

END translated;
